﻿using PoE_MxFilterGen.json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoE_MxFilterGen
{
    class TierGen
    {
        private static string iB;

        public static void Gen(string section, string api, string league, int minValue)
        {
            string giturl = settings.GetGIT();
            var js = web.ReadString($@"{giturl}/PoE-MxFilter-Structure/master/Tiers.txt");

            if (iB == null) { iB = @""""""; }
            string fn = @"gen\" + section + ".filter";
            File.AppendAllText(fn, string.Format("# Section: {0}", section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    HasExplicitMod ""Veiled""" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 112 255 112 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    MinimapIcon 1 Green Star" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    PlayEffect Green" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);

            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    FracturedItem True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 112 255 112 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    MinimapIcon 1 Green Star" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    PlayEffect Green" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);

            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SynthesisedItem True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 112 255 112 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    MinimapIcon 1 Green Star" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    PlayEffect Green" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);

            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Identified True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 0 0 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);

            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Corrupted True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 210 0 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);

            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    ItemLevel >= 75" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    ItemLevel <= 100" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 184 218 242" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);

            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    ItemLevel >= 60" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    ItemLevel <= 74" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 222 118 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);

            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, $"    BaseType {js}" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    ItemLevel >= 60" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    ItemLevel <= 74" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 222 118 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_tier.mp3""" + Environment.NewLine, Encoding.UTF8);
        }

    }
}
